import 'package:flutter/material.dart';

typedef Null OnResign(bool);

class BoardButtons extends StatelessWidget {
  BoardButtons({
    required this.width,
    required this.flipBoard,
    required this.onResign,
  });

  final double width;
  final VoidCallback flipBoard;
  final OnResign? onResign;

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.all(2.0),
      child: Container(
        height: 40,
        width: 200,
        decoration: BoxDecoration(
          color: Theme.of(context).backgroundColor.withOpacity(0.7),
          border: Border.all(color: Theme.of(context).dividerColor),
          borderRadius: BorderRadius.all(Radius.circular(10)),
        ),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.spaceAround,
          children: [
            IconButton(onPressed: flipBoard, icon: Icon(Icons.sync_rounded)),
            IconButton(
                onPressed: () async {
                  bool? didResign = await showDialog(
                      context: context,
                      builder: (context) {
                        return SimpleDialog(
                          title: Text('Do you want to resign?'),
                          children: [
                            Row(
                              mainAxisAlignment: MainAxisAlignment.spaceAround,
                              children: [
                                TextButton(
                                    onPressed: () {
                                      Navigator.pop(context, true);
                                    },
                                    child: Text('Yes')),
                                TextButton(
                                    onPressed: () {
                                      Navigator.pop(context, false);
                                    },
                                    child: Text('No')),
                              ],
                            )
                          ],
                        );
                      });

                  didResign = didResign ?? false;
                  if (onResign != null) onResign!(didResign);
                },
                icon: Icon(Icons.flag_rounded)),
          ],
        ),
      ),
    );
  }
}
