import 'package:flutter/material.dart';
import 'square_model.dart';
import '../utils/constants.dart';
import 'package:chessjs/pieces.dart';
import 'package:chessjs/chessjs.dart' as chessjs;

/// List of each square and their states

class ChessboardModel extends ChangeNotifier {
  ChessboardModel() {
    /// Initialize square names for the chessboard
    /// The state of the square would be set by the controller
    List<Square> board = [];
    squareList.expand((element) => element).forEach((square) {
      board.add(Square(squareName: square));
    });
    this._squares = board;
  }
  late List<Square> _squares;

  List<Square> get squares => _squares;

  updateSquareState(String squareName, Piece? state) {
    final s = _squares.firstWhere((square) => squareName == square.squareName);
    _squares
        .firstWhere((square) => squareName == square.squareName)
        .squareState = state;
    notifyListeners();
  }

//  updateBoard(List<chessjs>) {
//    _chessboard.squares.forEach((square) {
//      Piece? piece = _logic.get(square.squareName);
//      if (piece != null) {
//        square.squareState = piece;
//      }
//    });
//    final s = _squares.firstWhere((square) => squareName == square.squareName);
//    _squares
//        .firstWhere((square) => squareName == square.squareName)
//        .squareState = state;
//    notifyListeners();
//  }
}
