import 'package:hooks_riverpod/hooks_riverpod.dart';
import '../chessboard/controller.dart';
import '../models/chessboard_model.dart';
import '../models/move_history_model.dart';

final boardProvider =
    ChangeNotifierProvider.family<ChessboardModel, ChessboardController>(
        (ref, controller) {
  final board = controller.board;
  return board;
});

final moveHistoryProvider =
    ChangeNotifierProvider.family<MoveHistory, ChessboardController>(
        (ref, controller) {
  final moves = controller.moveHistory;
  return moves;
});
